'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mori = require('mori');

function combineReducers(reducers) {
  var reducerKeys = Object.keys(reducers);
  return function (state, action) {
    return reducerKeys.reduce(function (acc, key) {
      var reducer = reducers[key];
      var currentDomainState = (0, _mori.get)(state, key, undefined);
      var nextDomainState = reducer(currentDomainState, action);
      return (0, _mori.merge)(acc, (0, _mori.hashMap)(key, nextDomainState));
    }, state || (0, _mori.hashMap)(), reducers);
  };
};

exports.default = combineReducers;